#include "stdafx.h"
#include "findpass.h"
#include "Global.h"
#include "resource.h"
#include "UnAlz.h"

using namespace UNALZ;


static BOOL		g_bFinding = FALSE;
static BOOL		g_bStop=FALSE;
static TCHAR	g_szPathName[MAX_PATH];
static CHAR		g_szDestChars[512];




static void EnableControl(HWND hDlg, BOOL bEnable)
{
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_NUMBER),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_ALPHABET),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CAPITAL),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_SIMBOL),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_SPACE),		bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_ALL),		bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_START),		bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_CLOSE),	bEnable);
	

	SetDlgItemText(hDlg, IDC_BUTTON_STARTSTOP,	bEnable ? _T("") : _T("") );
}

static void DoFind(HWND hDlg)
{
	CUnAlz	alz;
	if(alz.Open(g_szPathName)==FALSE)
	{
		if(alz.GetLastErr()==CUnAlz::ERR_CORRUPTED_FILE)
		{
			MessageBox(hDlg, _T("ջ ̹Ƿ ȣ ã   ֽϴ."), APP, MB_OK);
		}
		else
		{
			MessageBox(hDlg, _T("ALZ  ƴϰų ջǾ      Դϴ."), APP, MB_OK);
			return;
		}
	}

	if(alz.IsEncrypted()==FALSE) {MessageBox(hDlg, _T("ȣ Ȱɸ ?"), APP, MB_OK); return;}

	CUnAlz::FileList fileList = alz.GetFileList();
	CUnAlz::FileList::iterator destfile;
	BOOL						bFind=FALSE;
	if(fileList.size()==0) {MessageBox(hDlg, _T("?"), APP, MB_OK); return;}

	for(destfile=fileList.begin(); destfile<fileList.end(); destfile++)
	{
		if(destfile->head.fileAttribute!=FILEATTR_FOLDER)
		{
			alz.SetCurrentFile(destfile);
			bFind = TRUE;
			break;
		}
	}

	if(bFind==false)
	{
		MessageBox(hDlg, _T(" ° ?"), APP, MB_OK);
		return;
	}


	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_ALL)))
	{
		strcpy(g_szDestChars, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890`~!@#$%^&*()_-=+\\|]}[{'\";:/?.>,<");
	}
	else
	{
		g_szDestChars[0]=0;
		if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_NUMBER)))		strcat(g_szDestChars, "0123456789");
		if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_ALPHABET)))	strcat(g_szDestChars, "abcdefghijklmnopqrstuvwxyz");
		if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_CAPITAL)))	strcat(g_szDestChars, "ABCDEFGHIJKLMNOPQRSTUVWXYZ");
		if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_SIMBOL)))		strcat(g_szDestChars, "`~!@#$%^&*()_-=+\\|]}[{'\";:/?.>,<");
		if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_SPACE)))		strcat(g_szDestChars, " ");
	}
	if(strlen(g_szDestChars)==0)
	{
		MessageBox(hDlg, _T("˻  ݾ.."), APP, MB_OK); 
		return;
	}


	int  i;
	char buf[512];
	int  pos[512];
	char* p;
	BOOL bSuccess=FALSE;
	BOOL bSkip=FALSE;
	int  len = strlen(g_szDestChars)-1;
	int  buflen;
	DWORD tick=GetTickCount();

	memset(buf, 0, sizeof(buf));
	memset(pos, 0, sizeof(pos));

	GetDlgItemText(hDlg, IDC_EDIT_START, buf, 256);
	if(strlen(buf))
	{
		int poscount=0;
		p = buf;
		while(*p)
		{
			for(i=0;i<=len;i++)
			{
				if(g_szDestChars[i]==*p)
				{
					pos[poscount]=i+1;
					break;
				}
			}
			p++;
			poscount++;
		}
		bSkip=TRUE;
	}

	buflen = strlen(buf);

	for(;;)
	{
		i = 0;
		/*
		for(;;)
		{
			if(pos[i]>=len)			// overflow
			{
				pos[i]=0;
				buf[i] = g_szDestChars[pos[i]];
				pos[i]++;

				i++;
				buf[i] = g_szDestChars[pos[i]];
			}
			else
			{
				buf[i] = g_szDestChars[pos[i]];
				pos[i]++;
				break;
			}
		}
		*/

		for(;;)
		{
			for(i=buflen-1;i>=0;i--)
			{
				if(pos[i]>len)		// overflow
				{
					pos[i]=0;		// ù° 
					buf[i] = g_szDestChars[pos[i]];
					pos[i]++;		// increment
				}
				else
				{
					buf[i] = g_szDestChars[pos[i]];
					pos[i]++;		// increment
					goto BREAK;
				}
			}

			// ڸ þ ..
			buflen ++;
			for(i=0;i<buflen;i++)
			{
				pos[i] = 0;
				buf[i] = g_szDestChars[pos[i]];
				pos[i]++;
			}
		}
		BREAK :

//		printf("%s\n", buf);
//		getchar();

		if(bSkip)
		{
			bSkip = FALSE;
			continue;
		}

		alz.setPassword(buf);
		if(alz.chkValidPassword()) 
		{
			SetDlgItemTextA(hDlg, IDC_EDIT_CURRENT,buf);
			//PumpUntilEmpty(NULL);
			alz.SetCurrentFile(destfile);
			if(alz.ExtractCurrentFileToBuf(NULL, 0)==TRUE)
			{
				bSuccess = TRUE;
				break;
			}
		}

		if(tick+100<GetTickCount())		// 100ms  ..
		{
			SetDlgItemTextA(hDlg, IDC_EDIT_CURRENT,buf);
			PumpUntilEmpty(NULL);
			tick = GetTickCount();
		}

		if(g_bStop) 
		{
			SetDlgItemTextA(hDlg, IDC_EDIT_START, buf);
			break;					// ..
		}

	}

	if(bSuccess)
	{
		SetDlgItemTextA(hDlg, IDC_EDIT_START, buf);
		MessageBox(hDlg, _T("~"), APP, MB_OK);
	}
	else
	{
		MessageBox(hDlg, _T("ãҽϴ."), APP, MB_OK);
	}

}



LRESULT CALLBACK FindPassDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		EnableControl(hDlg, TRUE);
		CenterWindow(hDlg);

		Button_SetCheck(GetDlgItem(hDlg, IDC_CHECK_NUMBER), TRUE);
		Button_SetCheck(GetDlgItem(hDlg, IDC_CHECK_ALPHABET), TRUE);
		Button_SetCheck(GetDlgItem(hDlg, IDC_CHECK_CAPITAL), TRUE);
		Button_SetCheck(GetDlgItem(hDlg, IDC_CHECK_SPACE), TRUE);

		return TRUE;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDC_BUTTON_STARTSTOP :
				if(g_bFinding)				// ã ̾..
				{
					g_bStop = TRUE;			// Ѵ.
					g_bFinding = FALSE;
					EnableControl(hDlg, TRUE);
				}
				else
				{
					g_bStop = FALSE;
					g_bFinding = TRUE;
					EnableControl(hDlg, FALSE);
					DoFind(hDlg);
					g_bStop = TRUE;			// Ѵ.
					g_bFinding = FALSE;
					EnableControl(hDlg, TRUE);
				}
				break;
			case IDC_BUTTON_CLOSE :
				EndDialog(hDlg, IDOK);
				break;
			case IDOK :
			case IDCANCEL :
				break;		/// ô´.
			}
		}
	}
	return FALSE;
}


BOOL DoFindPassword(HINSTANCE hInstance, HWND hWndParent, LPCTSTR szPathName)
{
	if(::lstrlen(szPathName)==0)
	{
		MessageBox(hWndParent, _T("ȣ ã    ּ"), APP, MB_OK);
		return FALSE;
	}

	if(::IsFile(szPathName)==FALSE)
	{
		MessageBox(hWndParent, _T("ȣ ã    ּ"), APP, MB_OK);
		return FALSE;
	}

	CUnAlz	unalz;
	if(unalz.Open(szPathName)==FALSE)
	{
		if(unalz.GetLastErr()==CUnAlz::ERR_CORRUPTED_FILE)
		{
			MessageBox(hWndParent, _T("  ջ ̰ų,  ALZ  ƴմϴ."), APP, MB_OK);
			return FALSE;
		}
	}

	if(unalz.IsEncrypted()==FALSE)
	{
		MessageBox(hWndParent, _T("  ȣɸ  ƴѵ?"), APP, MB_OK);
		return FALSE;
	}

	lstrcpy(g_szPathName, szPathName);

	DialogBox(hInstance, (LPCTSTR)IDD_FIND_PASS, hWndParent, (DLGPROC)FindPassDlgProc);
	return TRUE;
}

